chiark / gitweb /
5ffbd52c9e4b54012be49445ea75742e4df013bb
[dgit.git] / git-debpush
1 #!/bin/bash
2
3 # git-debpush -- create & push a git tag with metadata for an ftp-master upload
4 #
5 # Copyright (C) 2019 Sean Whitton
6 #
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 set -e$DGIT_TEST_DEBPUSH_DEBUG
21 set -o pipefail
22
23 # DESIGN PRINCIPLES
24 #
25 # - do not invoke dgit, do anything involving any tarballs, no network
26 #   access except `git push` right at the end
27 #
28 # - do not look at the working tree, like `git push` `git tag`
29 #
30 # - we are always in split brain mode, because that fits this workflow,
31 #   and avoids pushes failing just because dgit in the intermediary
32 #   service wants to append commits
33 #
34 # - if there is no previous tag created by this script, require a quilt
35 #   mode; if there is a previous tag, and no quilt mode provided, assume
36 #   same quilt mode as in previous tag created by this script
37
38 # ---- Helper functions and variables
39
40 us="$(basename $0)"
41
42 cleanup() {
43     if [ -d "$temp" ]; then
44         rm -rf "$temp"
45     fi
46 }
47
48 fail () {
49     echo >&2 "$us: $*";
50     exit 127;
51 }
52
53 badusage () {
54     fail "bad usage: $*";
55 }
56
57 get_file_from_ref () {
58     local path=$1
59
60     if git ls-tree --name-only -r "$branch" \
61             | grep -Eq "^$path$"; then
62         git cat-file blob $branch:$path
63     fi
64 }
65
66 # ---- Parse command line
67
68 getopt=$(getopt -s bash -o 'nfu:' \
69               -l 'no-push,force,branch:,remote:,distro:,upstream:,quilt:,gbp,dpm,\
70 baredebian,baredebian+git,baredebian+tarball' \
71               -n "$us" -- "$@")
72 eval "set - $getopt"
73 set -e$DGIT_TEST_DEBPUSH_DEBUG
74
75 git_tag_opts=()
76 pushing=true
77 force=false
78 distro=debian
79 quilt_mode=""
80 branch="HEAD"
81
82 while true; do
83     case "$1" in
84         '-n'|'--no-push') pushing=false;           shift;   continue ;;
85         '-u')             git_tag_opts+=(-u "$2"); shift 2; continue ;;
86         '-f'|'--force')   force=true;              shift;   continue ;;
87         '--gbp')          quilt_mode='gbp';        shift;   continue ;;
88         '--dpm')          quilt_mode='dpm';        shift;   continue ;;
89         '--branch')       branch=$2;               shift 2; continue ;;
90         '--remote')       remote=$2;               shift 2; continue ;;
91         '--distro')       distro=$2;               shift 2; continue ;;
92         '--quilt')        quilt_mode=$2;           shift 2; continue ;;
93         '--upstream')     upstream_tag=$2;         shift 2; continue ;;
94
95         '--baredebian'|'--baredebian+git')
96             quilt_mode=baredebian;         shift; continue ;;
97         '--baredebian+tarball')
98             quilt_mode=baredebian+tarball; shift; continue ;;
99
100         '--') shift; break ;;
101         *) badusage "unknown option $1" ;;
102     esac
103 done
104
105 if [ $# != 0 ]; then
106     badusage 'no positional arguments allowed'
107 fi
108
109 case "$quilt_mode" in
110     linear|auto|smash|nofix|gbp|dpm|unapplied|baredebian|baredebian+tarball|'') ;;
111     baredebian+git) quilt_mode="baredebian" ;;
112     *) badusage "invalid quilt mode: $quilt_mode" ;;
113 esac
114
115 # ---- Gather git information
116
117 remoteconfigs=()
118 push_branch=()
119
120 # Maybe $branch is a symbolic ref.  If so, resolve it
121 branchref="$(git symbolic-ref -q $branch || test $? = 1)"
122 if [ "x$branchref" != "x" ]; then
123    branch="$branchref"
124 fi
125 # If $branch is the name of a branch but it does not start with
126 # 'refs/heads/', prepend 'refs/heads/', so that we can know later
127 # whether we are tagging a branch or some other kind of committish
128 case "$branch" in
129     refs/heads/*) ;;
130     *)
131         branchref="$(git for-each-ref --format='%(objectname)' \
132                          '[r]efs/heads/$branch')"
133         if [ "x$branchref" != "x" ]; then
134             branch="refs/heads/$branch"
135         fi
136         ;;
137 esac
138
139 # If our tag will point at a branch, push that branch, and add its
140 # pushRemote and remote to the things we'll check if the user didn't
141 # supply a remote
142 case "$branch" in
143     refs/heads/*)
144         b=${branch#refs/heads/}
145         push_branch+=("$b")
146         remoteconfigs+=( branch.$b.pushRemote branch.$b.remote )
147         ;;
148 esac
149
150 # also check, if the branch does not have its own pushRemote or
151 # remote, whether there's a default push remote configured
152 remoteconfigs+=(remote.pushDefault)
153
154 if $pushing && [ "x$remote" = "x" ]; then
155     for c in "${remoteconfigs[@]}"; do
156         remote=$(git config "$c" || test $? = 1)
157         if [ "x$remote" != "x" ]; then break; fi
158     done
159     if [ "x$remote" = "x" ]; then
160         fail "pushing, but could not determine remote, so need --remote="
161     fi
162 fi
163
164 # ---- Gather source package information
165
166 temp=$(mktemp -d)
167 trap cleanup EXIT
168 mkdir "$temp/debian"
169 git cat-file blob "$branch":debian/changelog >"$temp/debian/changelog"
170 version=$(cd $temp; dpkg-parsechangelog -SVersion)
171 source=$(cd $temp; dpkg-parsechangelog -SSource)
172 target=$(cd $temp; dpkg-parsechangelog -SDistribution)
173 rm -rf "$temp"
174 trap - EXIT
175
176 # ---- Useful sanity checks
177
178 if ! $force; then
179
180     if [ "$target" = "UNRELEASED" ]; then
181         fail "UNRELEASED changelog"
182     fi
183
184     # TODO additional checks we might do:
185     #
186     # - are we uploading to a different suite from the last tag
187     #   (e.g. unstable after experimental)?  user should pass option to
188     #   confirm
189     #
190     # - walking backwards from $branch, if there is an archive/ strictly
191     #   before we reach most recent debian/ tag, error, this might be a
192     #   push of the dgit view to the maintainer branch
193
194 fi
195
196 # ---- Create the git tag
197
198 format="$(get_file_from_ref debian/source/format)"
199 case "$format" in
200     '3.0 (quilt)')  upstream=true ;;
201     '3.0 (native)') upstream=false ;;
202     '1.0'|'')
203         if get_file_from_ref debian/source/options | grep '^-sn *$'; then
204             upstream=false
205         elif get_file_from_ref debian/source/options | grep '^-sk *$'; then
206             upstream=true
207         else
208             fail 'please see "SOURCE FORMAT 1.0" in git-debpush(1)'
209         fi
210         ;;
211     *)
212         fail "unsupported debian/source/format $format"
213         ;;
214 esac
215
216 upstream_info=""
217 if $upstream; then
218     if [ "x$upstream_tag" = x ]; then
219         upstream_tag=$(git deborig --just-print --version="$version" \
220                            | head -n1)
221     fi
222     upstream_committish=$(git rev-parse "refs/tags/${upstream_tag}"^{})
223     upstream_info=" upstream-tag=$upstream_tag upstream=$upstream_committish"
224 fi
225
226 # convert according to DEP-14 rules
227 git_version=$(echo $version | tr ':~' '%_' | sed 's/\.(?=\.|$|lock$)/.#/g')
228
229 debian_tag="$distro/$git_version"
230
231 # If the user didn't supply a quilt mode, look for it in a previous
232 # tag made by this script
233 if [ "x$quilt_mode" = "x" ] && [ "$format" = "3.0 (quilt)" ]; then
234     set +o pipefail             # perl will SIGPIPE git-log(1) here
235     tag=$(git log --pretty=format:'%D' --decorate=full "$branch" \
236         | perl -wne 'use Dpkg::Version;
237                 @pieces = split /, /, $_;
238                 @debian_tag_vs = sort {version_compare($b, $a)}
239                     map { m|tag: refs/tags/debian/(.+)| ? $1 : () } @pieces;
240                 if (@debian_tag_vs) { print "debian/$debian_tag_vs[0]\n"; exit }')
241     if [ "x$tag" != "x" ]; then
242         quilt_mode=$(git cat-file -p $(git rev-parse "$tag") \
243                          | perl -wne \
244                                 'm/^\[dgit.*--quilt=([a-z+]+).*\]$/;
245                                  if ($1) { print "$1\n"; exit }')
246     fi
247     set -o pipefail
248 fi
249
250 quilt_mode_text=""
251 if [ "$format" = "3.0 (quilt)" ]; then
252     if [ "x$quilt_mode" = "x" ]; then
253         echo >&2 "$us: could not determine the git branch layout"
254         echo >&2 "$us: please supply a --quilt= argument"
255         exit 1
256     else
257         quilt_mode_text=" --quilt=$quilt_mode"
258     fi
259 fi
260
261 git tag "${git_tag_opts[@]}" -s -F- "$debian_tag" "$branch" <<EOF
262 $source release $version for $target
263
264 [dgit distro=$distro split$quilt_mode_text]
265 [dgit please-upload$upstream_info]
266 EOF
267
268 # ---- Do a git push
269
270 if $pushing; then
271     # xxx when user can specify upstream_tag, must cope with spaces
272     git push "$remote" "${push_branch[@]}" $upstream_tag "$debian_tag"
273 fi